<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Judul informasi" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="infos" ref="infoTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="Tanggal"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>           
            <el-table-column
                label="Judul"
                width="300">
                <template slot-scope="scope">
                    <span>{{ scope.row.title }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Konten"
                width="350">
                <template slot-scope="scope">
                    <span>{{ truncate(scope.row.body) }}</span>
                </template>
            </el-table-column>            
            <el-table-column
                label="Author"
                width="150">
                <template slot-scope="scope">
                    <span>{{ scope.row.user.profile.fullname }}</span>
                </template>
            </el-table-column>
            <el-table-column
                align="center"
                label="Komentar"
                width="100">
                <template slot-scope="scope">
                    <span>{{ scope.row.total_comment}}</span>
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'info', 'viewown']" type="text" @click="handleView(row)">Lihat Detil</el-button>
                    <el-button v-permission="[row, 'info', 'deleteown']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch" />

        <el-dialog title="Detil Informasi" :visible.sync="showDetailDialog" width="30%" :show-close="false">
            <el-carousel trigger="click" v-if="info.medias.length > 0">
                <el-carousel-item v-for="item in info.medias" :key="item.id">
                    <el-image
                    style="width: 100%"
                    :src="item.url.large"
                    fit="fit"></el-image>
                </el-carousel-item>
            </el-carousel>
            <h3>{{ info.title }}</h3>
            <small class="display-block">Oleh: {{ info.author }}, {{ info.posted }}</small>
            <br>
            <div>{{ info.body }}</div>
            <br>
            <h3>Komentar</h3>
            <div v-if="comments.length > 0">
                <el-alert
                     v-for="comment in comments" 
                     v-bind:key="comment.id"
                    type="info"
                    :closable="false">
                    <div slot="title">
                        <small class="display-block"><strong>Oleh: {{ comment.user.profile.fullname }}, {{ dateFormat(comment.updated) }}</strong></small>
                        <span class="display-block">{{ comment.comment }}</span>
                        <br>
                        <div class="block" v-if="comment.medias.length > 0" >
                            <el-image
                            v-for="media in comment.medias"
                            v-bind:key="media.id"
                            style="width: 100px; height: 100px"
                            :src="media.url.medium"
                            fit="fill"></el-image>
                        </div>
                        <div class="block" v-if="comment.mapurl != null" >
                            <el-image
                            style="width:100%"
                            :src="comment.mapurl"
                            fit="fill"></el-image>
                        </div>
                    </div>
                </el-alert>
            </div>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showCommentDialog = false" size="medium">Tutup</el-button>
            </span>
        </el-dialog>
    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight, truncate } from '@/utils/index';

export default {
    name: 'Info',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){
        return {
            tableLoading: false,
            showDetailDialog: false,
            showCommentDialog: false,
            filter: {
                keyword: ''
            },
            info: {
                title: '',
                body: '',
                posted: '',
                author: '',
                medias: '',
                comments: []
            }
        };
    },
    computed: {
        tableHeight,
        ...mapGetters('auth', ['token']),
        ...mapGetters('user', ['me', 'users']),
        ...mapGetters('info', ['infos', 'pagination']),
        ...mapGetters('comment', ['comments']),
    },
    created() {
        this.getInfos();
    },
    methods: {
        playSound,
        dateFormat,
        truncate,
        getInfos() {
            this.tableLoading = true;
            this.$store.dispatch('info/getInfos', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleSearch(){

            let payload = {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }

            this.tableLoading = true;
            this.$store.dispatch('info/getInfos', payload).then(() => {
                this.tableLoading = false;
            });
        },
        handleView(info){      
            const self = this; 

            self.info.title = info.title;
            self.info.body = info.body;
            self.info.posted = dateFormat(info.updated);
            self.info.author = info.user.profile.fullname;
            self.info.medias = info.medias;

            // get comments
            self.$store.dispatch('comment/getComments', {
                info: info.id,
                page: 1,
                perpage: 100
            }).then(() => {
                self.info.comments = self.comments;
                self.showDetailDialog = true;
            });

        },
        handleDelete(info){
            this.$confirm('Anda mencoba untuk menghapus data informasi, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('info/deleteInfo', {
                    id: info.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
    }

}
</script>
